
#-----------------------------------------------------------------------------
# MACRO TO ADD A COMPILER DEFINITION WHICH ADDS ALSO THE DEF 
# INTO DOXYGEN PREDEFINED VAR 
# (OTHERWISE DOXYGEN WOULD NOT PARSE THE FILES BLOCKED)
MACRO(CREA_DEFINE DEF)
  MESSAGE(STATUS "* Added definition -D${DEF}")
  ADD_DEFINITIONS( -D${DEF} )
  SET(CREA_DEFINITIONS
    ${CREA_DEFINITIONS};${DEF}
    CACHE 
    STRING 
    ""
    FORCE)
  MARK_AS_ADVANCED(CREA_DEFINITIONS)
ENDMACRO(CREA_DEFINE)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# MACRO TO ADD A COMPILER DEFINITION WITH VALUE WHICH ADDS ALSO THE DEF 
# INTO DOXYGEN PREDEFINED VAR 
# (OTHERWISE DOXYGEN WOULD NOT PARSE THE FILES BLOCKED)
MACRO(CREA_DEFINE_WITH_VAL DEF VAL)
  MESSAGE(STATUS "* Added definition -D${DEF}=${VAL}")
  ADD_DEFINITIONS( -D${DEF}=${VAL} )
  SET(CREA_DEFINITIONS
    ${CREA_DEFINITIONS};${DEF}=${VAL}
    CACHE 
    STRING 
    ""
    FORCE)
  MARK_AS_ADVANCED(CREA_DEFINITIONS)
ENDMACRO(CREA_DEFINE_WITH_VAL)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
MACRO(CREA_DEFINE_OPERATING_SYSTEM )
  IF(APPLE)
   CREA_DEFINE(MACOSX)
  ELSE(APPLE)
    IF("${CMAKE_SYSTEM}" MATCHES "Linux")
      CREA_DEFINE(LINUX)
    ELSE("${CMAKE_SYSTEM}" MATCHES "Linux")
      IF(WIN32)
        CREA_DEFINE(WIN32)
      ELSE(WIN32)
        MESSAGE(FATAL_ERROR "${CMAKE_SYSTEM} unsupported ! Build at your own risks ! (remove this line from kernel/cmake/BBTKAddDefinitions.cmake)")
      ENDIF(WIN32)
    ENDIF("${CMAKE_SYSTEM}" MATCHES "Linux")
  ENDIF(APPLE) 
ENDMACRO(CREA_DEFINE_OPERATING_SYSTEM)
#-----------------------------------------------------------------------------

