
#========================================================================
# Creates a directory if it does not exist
MACRO(CREA_MKDIR DIR)
  IF(NOT IS_DIRECTORY ${DIR})
    MESSAGE(STATUS "* Creating directory '${DIR}'")
    FILE(MAKE_DIRECTORY ${DIR})
  ENDIF(NOT IS_DIRECTORY ${DIR})
ENDMACRO(CREA_MKDIR)
#========================================================================

#========================================================================
# COPIES A DIRECTORY EXCLUDING CVS ENTRIES
MACRO(CREA_CPDIR SOURCE DEST)
  FILE(GLOB_RECURSE NAMES RELATIVE ${SOURCE} ${SOURCE}/*)
  FOREACH( NAME  ${NAMES})
    STRING(SUBSTRING ${NAME} 0 3 subStrTmp )
    IF( NOT subStrTmp STREQUAL "../" )
      STRING(REGEX MATCH "CVS" CVSSUBS_FOUND ${NAME} )
      IF( NOT CVSSUBS_FOUND STREQUAL "CVS" )
	CONFIGURE_FILE(
	  ${SOURCE}/${NAME} 
	  ${DEST}/${NAME}
	  COPYONLY )
      ENDIF( NOT CVSSUBS_FOUND STREQUAL "CVS" )
    ENDIF( NOT subStrTmp STREQUAL "../" )
  ENDFOREACH(NAME)
ENDMACRO(CREA_CPDIR)
#========================================================================
